<template>
  <b-container class="login-container">
    <b-row class="login-container__row">
      <b-col class="login-fields" cols="12">
        <b-row class="login-fields__title">Salon Login</b-row>
        <br />
        <b-row class="login-fields__form-part">
          <b-col xl="5" lg="5" md="8" sm="12" cols="12">
            <b-form @submit.prevent="handleLogin">
              <b-form-group
                id="input-group-1"
                label=""
                label-for="input-1"
                description=""
              >
                <b-form-input
                  id="input-1"
                  v-model="form.userID"
                  type="text"
                  placeholder="Enter ID"
                  required
                  class="id-login"
                  @keydown="handleVerifyName($event)"
                ></b-form-input>
              </b-form-group>

              <b-form-group
                id="input-group-2"
                label=""
                label-for="input-2"
                description=""
              >
                <b-form-input
                  id="input-2"
                  v-model="form.password"
                  type="password"
                  placeholder="Enter password"
                  required
                  class="password-login"
                ></b-form-input>
              </b-form-group>

              <b-button class="btn-login" block type="submit" variant="primary"
                >Login</b-button
              >
            </b-form>
          </b-col>
        </b-row>
        <br/>
        <b-row class="login-fields__warning" v-if="warning==true">
          <b-col>
            Login Failed, ID or password is invalid
            <br/>
            ID can't contain specific character and ID length can't be over 30 characters
            <br/>
            Your Password is too weak. Password must have at least 8 character
          </b-col>
        </b-row>
      </b-col>
    </b-row>
    <!-- <b-modal ref="my-modal" id="my-modal" hide-footer title="Alert" style="border: 1px solid black; padding: 0px"> -->
    <b-modal ref="my-modal" id="my-modal" hide-footer title="Alert">
      <div class="container">
        <div class="row login-alert">
          <div class="col-12 login-alert__text">
            No member matches the information you entered.
            <br />
            Please check the ID and password.
          </div>
        </div>
        <div class="row close-btn">
          <div class="col-12 close-btn__div">
            <a class="btn btn-primary close-btn__div__a" @click="closeModal"
              >Close</a
            >
          </div>
        </div>
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import "./LoginForm.scss";
import * as api from './../../apis/api';
import * as constant from "../../libs/Constant";
export default {
  name: "LoginForm",
  props: {},
  data() {
    return {
      constant,
      form: {
        password: "",
        solutionId: "3002",
        userID: "",
        shopId: -1,
        authToken: "",
      },
      warning: false
    };
  },
  methods: {
    openModal() {
      this.$bvModal.show("my-modal");
    },
    closeModal() {
      this.$bvModal.hide("my-modal");
    },
    generateUUID() {
      // Public Domain/MIT
      var d = new Date().getTime(); //Timestamp
      var d2 =
        (typeof performance !== "undefined" &&
          performance.now &&
          performance.now() * 1000) ||
        0; //Time in microseconds since page-load or 0 if unsupported
      return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(
        /[xy]/g,
        function (c) {
          var r = Math.random() * 16; //random number between 0 and 16
          if (d > 0) {
            //Use timestamp until depleted
            r = (d + r) % 16 | 0;
            d = Math.floor(d / 16);
          } else {
            //Use microseconds since page-load if supported
            r = (d2 + r) % 16 | 0;
            d2 = Math.floor(d2 / 16);
          }
          return (c === "x" ? r : (r & 0x3) | 0x8).toString(16);
        }
      );
    },
    async handleLogin() {
      var result_api = await api.postAPIs(constant.LOGIN_API, this.form, null, false);
      if (this.form.userID.length > 30 || this.form.password < 8){
        this.warning = true;
        return;
      }
      if (!result_api.data.result) {
        this.openModal();
      } else {
        if (result_api.status === 200 && result_api.data.result) {
          var user_info = result_api.data.result.userAuthInfo;
          console.log("user_info = ", user_info);
          this.shopId = user_info.shopId;
          this.authToken = user_info.authToken;
          sessionStorage.setItem("token", user_info.authToken);
          sessionStorage.setItem("shopId", user_info.shopId);
          sessionStorage.setItem("accessToken", this.generateUUID());
          this.$router.push("/client").catch((err) => {
            console.log(err);
          });
        } else {
          alert("Re-render");
          this.form.userID = "";
          this.form.password = "";
        }
      }
    },
    handleVerifyName(event) {
      var not_allowed = [
        "!",
        "@",
        "#",
        "$",
        "%",
        "^",
        "&",
        "*",
        "(",
        ")",
        "-",
        "+",
        "=",
        "[",
        "]",
        "{",
        "}",
        "\\",
        "|",
        ";",
        ":",
        "'",
        '"',
        "<",
        ",",
        ">",
        ".",
        "?",
        "/",
      ];
      if (not_allowed.includes(event.key) || this.form.userID.length >= 30) {
        if (event.key != "Backspace")
          event.preventDefault();
      }
    },
  },
  async mounted() {
    var token = sessionStorage.getItem("token");
    var shopId = sessionStorage.getItem("shopId");
    if (token && shopId) {
      this.$router.push("/client").catch((err) => {
        console.log(err);
      });
    }
  },
};
// https://ahasoft-salon-admin-http-aggregator-dev.azurewebsites.net/api/aggr/v1/auth/Login/Subscriber?culture=en-US&ui-culture=en-US
// ahasoft-salon-admin-http-aggregator-dev.azurewebsites.net
</script>


<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>
</style>
